<!--
  ~ Copyright (c) 2024 LOBA
  ~ 
  ~ Permission is hereby granted, free of charge, to any person obtaining a copy of
  ~ this software and associated documentation files (the "Software"), to deal in
  ~ the Software without restriction, including without limitation the rights to
  ~ use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
  ~ the Software, and to permit persons to whom the Software is furnished to do so,
  ~ subject to the following conditions:
  ~ 
  ~ The above copyright notice and this permission notice shall be included in all
  ~ copies or substantial portions of the Software.
  ~ 
  ~ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  ~ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
  ~ FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
  ~ COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
  ~ IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  ~ CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  ~ 
  ~ SPDX-License-Identifier: MIT
  ~ 
  ~ Contributors:
  ~     [name] - [contribution]
-->

<template>
    <div class="catalog-page">

        <div style="height: 40px;"></div>

        <div>
            <div class="datatable artifact-table">
                <div class="datatable-body">

                    <div class="datatable-body-row">
                        <div class="datatable-body-row-preview">
                            <div class="artifact-details-table no-line">

                                <div class="kpi">
                                    <div>
                                        <h3>Consistency</h3>
                                        <p><span>100</span></p>
                                    </div>
                                    <div>
                                        <h3>Accuracy</h3>
                                        <p><span>54</span></p>
                                    </div>
                                    <div>
                                        <h3>Completness</h3>
                                        <p><span>29</span></p>
                                    </div>
                                    <div>
                                        <h3>Timeliness</h3>
                                        <p><span>12</span></p>
                                    </div>
                                    <div>
                                        <h3>Uniqueness</h3>
                                        <p><span>13</span></p>
                                    </div>
                                    <div>
                                        <h3>Validity</h3>
                                        <p><span>87</span></p>
                                    </div>
                                </div>

                            </div>
                        </div>
                    </div>

                    <div class="datatable-body-row">
                        <div class="datatable-body-row-preview">
                            <div class="artifact-details-table no-line">
                                <div class="line">
                                    <div>
                                        <span>Source IP Address</span>
                                    </div>
                                    <div>
                                        0.0
                                    </div>
                                    <div>
                                    </div>
                                    <div>
                                    </div>
                                    <div>
                                    </div>
                                    <div>
                                    </div>
                                </div>
                                <div class="line">
                                    <div>
                                        <span>Source port</span>
                                    </div>
                                    <div>
                                        0.0
                                    </div>
                                    <div>

                                    </div>
                                    <div>

                                    </div>
                                    <div>

                                    </div>
                                    <div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="datatable-body-row">
                        <div class="datatable-body-row-preview">
                            <div class="artifact-details-table no-line">
                                <img src="assets/images/rule.png" alt="">
                            </div>
                        </div>
                    </div>


                </div>
            </div>
        </div>

    </div>
</template>
<script setup lang="ts">
import type DataTableI from '~/interfaces/datatable';
import { ref } from 'vue';

const props = defineProps({
    artifactsData: {
        type: Object,
        default: () => ({ artifacts: [] })
    }
});

const artifacts = ref(props.artifactsData);

useHead({
    title: 'Catalog - DATAMITE'
});

const showCreateDatasetModal = ref(false);

const close = () => {
    showCreateDatasetModal.value = false;
};

// make the function close available to emit in other components
defineExpose({ close });


interface ArtifactsArray {
    id: number;
    name: string;
    type: string;
    summary: string;
    description: string;
    distinctEntries: '',
    missingValues: '',
    percentageMissingValues: '',
    uniquenessEntries: '',
    updatedAt: string;
    createdAt: string;
}

// get artifacts row details

async function populateRows() {
    const rows = props?.artifactsData?.map((artifact: ArtifactsArray, index: number) => ({
        id: artifact?.id,
        name: artifact?.name,
        type: 'Artifact',
        summary: '',
        description: '',
        distinctEntries: '',
        missingValues: '',
        percentageMissingValues: '',
        uniquenessEntries: '',
        edited_at: '',
        createdAt: '',
        actions: ''
    }));

    const detailedRows = await Promise.all(
        props?.artifactsData?.map(async (artifact: ArtifactsArray) => {
            try {
                const details = await useFetchAuth(`/catalogs/${artifact.id}`) as ArtifactsArray;

                return {
                    id: artifact?.id,
                    name: artifact?.name,
                    type: 'Artifact',
                    summary: details?.summary,
                    description: details?.description,
                    distinctEntries: '',
                    missingValues: '',
                    percentageMissingValues: '',
                    uniquenessEntries: '',
                    edited_at: formatDate(details?.updatedAt),
                    created_at: formatDate(details?.createdAt),
                    actions: ''

                };
            } catch (error) {
                console.error(`Failed to fetch details for dataset ${artifact.id}:`, error);
                return {
                    id: artifact?.id,
                    name: artifact?.name,
                    type: 'Artifact',
                    summary: '',
                    description: '',
                    distinctEntries: '',
                    missingValues: '',
                    percentageMissingValues: '',
                    uniquenessEntries: '',
                    edited_at: '',
                    created_at: '',
                    actions: ''
                };
            }
        })
    );

    data.value.rows = detailedRows;
}

onMounted(() => {
    populateRows();
});

watch(() => props.artifactsData, () => {
    populateRows();
}, { deep: true });

const data = ref<DataTableI>({
    options: {
        tableName: 'artifact-table',
        detailsPath: '/catalog/artifact/',
        allowCheckRow: false,
        favourites: false,
        previewComponent: 'ArtifactDetails',
    },
    columns: [
        {
            id: 1,
            name: 'name',
            label: 'Name',
            filterType: 'text',
            width: '250px',
            combineColumn: 'type',
            renderComponent: 'TableColumnsName'
        },
        {
            id: 2,
            name: 'distinctEntries',
            label: 'Distinct Entries',
            filterType: 'select',
            width: '150px'
        },
        {
            id: 3,
            name: 'missingValues',
            label: 'Missing values',
            filterType: 'select',
            width: '150px'
        },
        {
            id: 4,
            name: 'percentageMissingValues',
            label: 'Percentage missing values',
            width: '150px'
        },
        {
            id: 5,
            name: 'uniquenessEntries',
            label: 'Uniqueness Entries',
            filterType: 'select',
            width: '140px'
        },
        {
            id: 6,
            name: 'edited_at',
            label: 'Edited at',
            width: '70px'
        },
        {
            id: 7,
            name: 'actions',
            label: 'Actions',
            width: '80px',
            hideLabel: true
        }
    ],
    rows: [{
        id: 1,
        name: 'Dataset 1',
        type: 'Artifact',
        summary: '',
        description: '',
        distinctEntries: '',
        missingValues: '',
        percentageMissingValues: '',
        uniquenessEntries: '',
        edited_at: '',
        created_at: '',
        actions: ''
    }]
});


const sortOptions = ref(['Last modified first', 'Last modified last', 'Option 3']);

const previewVisible = ref<number | null>(null);

const togglePreview = (index: number) => {
    previewVisible.value = previewVisible.value === index ? null : index;
};

const isPreviewVisible = (index: number) => {
    return previewVisible.value === index;
};

const goDetails = () => {
    navigateTo('/catalog/artifact/1');
}


</script>